$columns: 12;
$breakpoint-mobile: "screen and (min-width: 35em)"; //586 & higher
$breakpoint-tab: "screen and (min-width: 48em)"; //768 & higher
$breakpoint-desktop: "screen and (min-width: 64em)"; //1024 & higher
$breakpoint-hires: "screen and (min-width: 80em)"; //1280 & higher

@mixin grid($i) {
    width: 100% / $columns * $i;
    -webkit-flex-basis: 100% / $columns * $i;
    -ms-flex-preferred-size: 100% / $columns * $i;
    flex-basis: 100% / $columns * $i;
}

@for $i from 1 through $columns {
    .col-#{$i}-#{$columns} {
        @include grid($i);
    }
    .col-auto {
        flex: 1;
    }
}

@media #{$breakpoint-mobile} {
    @for $i from 1 through $columns {
        .col-xs-#{$i}-#{$columns} {
            @include grid($i);
        }
        .col-xs-auto {
            flex: 1;
        }
    }
}

@media #{$breakpoint-tab} {
    @for $i from 1 through $columns {
        .col-sm-#{$i}-#{$columns} {
            @include grid($i);
        }
        .col-sm-auto {
            flex: 1;
        }
    }
}

@media #{$breakpoint-desktop} {
    @for $i from 1 through $columns {
        .col-md-#{$i}-#{$columns} {
            @include grid($i);
        }
        .col-md-auto {
            flex: 1;
        }
    }
}

@media #{$breakpoint-hires} {
    @for $i from 1 through $columns {
        .col-lg-#{$i}-#{$columns} {
            @include grid($i);
        }
        .col-lg-auto {
            flex: 1;
        }
    }
}
